export declare const enum Direction {
    vertical = "vertical",
    horizontal = "horizontal",
    all = "all",
    no = "no"
}
export interface Ship {
    pos: number[];
    length: number;
    posibleDirection: Direction;
}
export interface ShipMan {
    ships: Ship[];
    allPos: Map<number, number>;
}
export interface ShipClassInterface {
    shipman: ShipMan;
    add(curr: number): ShipClassInterface;
    gridSize: number;
    shipsNo: number;
}
export declare class ShipClass implements ShipClassInterface {
    _gridSize: number;
    _shipman: ShipMan;
    _shipsNo: number;
    constructor(shipman: ShipMan, gridSize: number, shipsNo: number);
    protected shipBefore(x: number): boolean;
    get gridSize(): number;
    get shipsNo(): number;
    add(curr: number): ShipClassInterface;
    protected checkValidity(curr: number, len: number, ship?: Ship): Direction;
    private verticalCan;
    protected inHorizontalLine(curr: number, n: number): boolean;
    private horizontalCan;
    get shipman(): ShipMan;
}
